//---------------------------------------------------------------------------------------------------------------------
//--------------------------------------Edit this part for LCD pins configuration--------------------------------------
//---------------------------------------------------------------------------------------------------------------------


//Change PIOA to port name you want.(eg. AT91C_BASE_PIOB ...)
#define _LCD_Port_Base 	AT91C_BASE_PIOA

//To change the RS and En pin, change the numbers. (Zero based)
#define __En_pin 9
#define __RS_pin 8

//Set _DB_offset for DB4 pin:
//DB4->PORTx.(_DB_offset) ,DB5->PORTx.(_DB_offset+1) ,DB6->PORTx.(_DB_offset+2) ,DB7->PORTx.(_DB_offset+3)
#define _DB_offset 0


//Connect RW pin to Ground(GND) !!!


/*----------------------------------------------------------------------------------------------------------------

Use the functions below:
	
	void lcd_command(unsigned char cmd);
	void lcd_char(unsigned char dta);
	void lcd_init(void);
	void lcd_clear(void);
	void lcd_home(void);
	void lcd_xy(unsigned char x,unsigned char y);
	void lcd_string(unsigned char *str);
-----------------------------------------------------------------------------------------------------------------*/



//---------------------------------------------------------------------------------------------------------------------
//---------------------------------------------Don't change parts below------------------------------------------------
//---------------------------------------------------------------------------------------------------------------------


#define lcd_port_PER _LCD_Port_Base->PIO_PER
#define lcd_port_PSR _LCD_Port_Base->PIO_PSR
#define lcd_port_OER _LCD_Port_Base->PIO_OER
#define lcd_port_OSR _LCD_Port_Base->PIO_OSR
#define lcd_port_SODR _LCD_Port_Base->PIO_SODR
#define lcd_port_CODR _LCD_Port_Base->PIO_CODR
#define lcd_port_ODSR _LCD_Port_Base->PIO_ODSR



unsigned int __i;
#define _wait for(__i=0;__i<0x8FF;__i++);

void lcd_command(unsigned char cmd);
void lcd_char(unsigned char dta);
void lcd_init(void);
void lcd_clear(void);
void lcd_home(void);
void lcd_xy(unsigned char x,unsigned char y);
void lcd_string(unsigned char *str);



void _En_H(){
	lcd_port_SODR=lcd_port_ODSR|(1<<__En_pin);
}
void _En_L(){
	lcd_port_CODR=(1<<__En_pin);
}
void _RS_H(){
	lcd_port_SODR=lcd_port_ODSR|(1<<__RS_pin);
}
void _RS_L(){
	lcd_port_CODR=(1<<__RS_pin);
}


	
void lcd_command(unsigned char cmd){
	_En_H();
	_RS_L();
	_wait;
	lcd_port_CODR = 0xF*(1<<_DB_offset);
	lcd_port_SODR = (cmd /16)*(1<<_DB_offset);
	_wait;
	_En_L();
	_wait;
	_En_H();
	_wait;
	lcd_port_CODR = 0xF*(1<<_DB_offset);
	lcd_port_SODR = (cmd & 0x0F)*(1<<_DB_offset);
	_wait;
	_En_L();
}

void lcd_init(){
	lcd_port_PER = lcd_port_PSR | 0x3FF;
	lcd_port_OER = lcd_port_OSR | 0x3FF;
	_wait;
	lcd_command(0x28);
	lcd_command(0x02);
	lcd_command(0x01);
	lcd_command(0x0C);
}

void lcd_clear(){
	lcd_command(0x01);
}

void lcd_home(){
	lcd_command(0x02);
}

void lcd_char(unsigned char dta){
	_En_H();
	_RS_H();
	_wait;
	lcd_port_CODR = 0xF*(1<<_DB_offset);
	lcd_port_SODR = (dta /16)*(1<<_DB_offset);
	_wait;
	_En_L();
	_wait;
	_En_H();
	_wait;
	lcd_port_CODR = 0xF*(1<<_DB_offset);
	lcd_port_SODR = (dta & 0x0F)*(1<<_DB_offset);
	_wait;
	_En_L();
}

void lcd_xy(unsigned char x,unsigned char y){
	if(y)
		lcd_command(0xC0 | x);
	else
		lcd_command(0x80 | x);
}

void lcd_string(unsigned char *str){
	int i=0;
	while(str[i]!='\0'){
		lcd_char(str[i]);
		i++;
	}
}
